proc defbud_IM_IN {name source msg auto} {
    set ::TAC(lastbud) $source
    if { $::TAC(autobud) == 1 } then { set e 0
        foreach j [list 0 1 2 3 4 5 6 7 8 9] {
            if { [normalize $::TAC(defbud,$j)] == [normalize $source] } {
                set e 1
                break
            }
        }
        if { $e == 0 } {
            foreach j [list 0 1 2 3 4 5 6 7 8 9] {
                if { $::TAC(defbud,$j) == "" } {
                    set ::TAC(defbud,$j) [normalize $source]
                    tac_output "Buddy \#$j is now $source."
                    break 
                }
            }
        }
    }
}

proc tac_cmd_autobuddy {exp line} {
    if { $::TAC(autobud) == 0 } then {
        set ::TAC(autobud) 1
        tac_output "Autobuddy is now ON."
    } else {
        set ::TAC(autobud) 0
        tac_output "Autobuddy is now OFF."
    }
}

proc tac_cmd_lsbuddy {exp line} {
    tac_output "Defined Buddies"
    tac_output "---------------"
    tac_output "Last Buddy: $::TAC(lastbud)"
    foreach j [list 0 1 2 3 4 5 6 7 8 9] {
        tac_output "Buddy $j: $::TAC(defbud,$j)"
    }
}

proc tac_cmd_rmbuddy {exp line} {
    if {![regexp -- {^(/[a-zA-Z0-9]+) +([0-9]) *$} $line match cmd num]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if { $::TAC(defbud,$num) == "" } {
        tac_output "Buddy $num not defined."
    } else {
        tac_output "$::TAC(defbud,$num) (buddy \#$num) removed from list."
        set ::TAC(defbud,$num) ""
    }
}

proc tac_cmd_mvbuddy {exp line} {
    if {![regexp -- {^(/[a-zA-Z0-9]+) +([0-9]) +([0-9]) *$} $line match cmd num1 num2]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    set tmp $::TAC(defbud,$num2)
    set ::TAC(defbud,$num2) $::TAC(defbud,$num1)
    set ::TAC(defbud,$num1) $tmp
    if { "$::TAC(defbud,$num1)"=="" } then {
        tac_output "Buddy \#$num1 is undefined."
    } else {
        tac_output "Buddy \#$num1 is now $::TAC(defbud,$num1)"
    }
    if { "$::TAC(defbud,$num2)"=="" } then {
        tac_output "Buddy \#$num2 is undefined."
    } else {
        tac_output "Buddy \#$num2 is now $::TAC(defbud,$num2)"
    }
}

proc tac_cmd_sdefault {exp line} {
    if {![regexp -- {^(/[a-zA-Z0-9]+) +([0-9]) +([a-zA-Z0-9]+) *$} $line match cmd num name]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    set ::TAC(defbud,$num) $name
    tac_output "Buddy \#$num is now $::TAC(defbud,$num)."
}

proc tac_cmd_default {exp line} {
    if {![regexp -- {^([0-9]) (.*)$} $line match cmd msg]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if {"$::TAC(defbud,$cmd)"==""} { 
        tac_output "Buddy $cmd not defined"
        return 
    }
    toc_send_im $::NSCREENNAME $::TAC(defbud,$cmd) $msg
    tac_log_outIM $::TAC(defbud,$cmd) $msg 0
}

proc tac_cmd_last {exp line} {
    if {![regexp -- {^(\.) (.*)$} $line match cmd msg]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    if { "$::TAC(lastbud)"=="" } {
        tac_output "No users have IMed you"
    } else {
        toc_send_im $::NSCREENNAME $::TAC(lastbud) $msg
        tac_log_outIM $::TAC(defbud,$cmd) $msg
    }
}

tac_register_cmd "^/s "       tac_cmd_sdefault       "  /s  num user     set buddy number num"
tac_register_cmd "^/sl$"      tac_cmd_lsbuddy        "  /sl              list previously defined buddies"
tac_register_cmd "^/sr "      tac_cmd_rmbuddy        "  /sr num          remove buddy num"
tac_register_cmd "^/sm "      tac_cmd_mvbuddy        "  /sm num1 num2    move buddy num1 to slot num2"
tac_register_cmd "^/au$"      tac_cmd_autobuddy      "  /au              auto set buddy number on new IM (toggle)"
tac_register_cmd "^\\. "      tac_cmd_last           "  . message        send message to last user who IMed you"
tac_register_cmd "^\[0\-9\] " tac_cmd_default        "  <num> message    send message to buddy #num"

toc_register_func * IM_IN defbud_IM_IN

foreach j [list 0 1 2 3 4 5 6 7 8 9] {
    set TAC(defbud,$j) ""
}

set TAC(autobud) 0
set TAC(lastbud) ""
