proc log_SIGN_ON {name version} {
    if { $::TAC(log) == 0 } { return }
    set fn [open $::TAC(logfile) a]
    puts $fn "=== Log start [clock format [clock seconds] -format "%A, %B %d %Y %I:%M:%S%p"] ==="
    close $fn
}

proc log_IM_IN {name source msg auto} {
    if { $::TAC(log) == 0 } { return }
    set fn [open $::TAC(logfile) a]
    set text [unHTML $msg]
    if { $::TAC(time12) == 12 } {
        set tmst [clock format [clock seconds] -format %I:%M:%S%p]
    } else {
        set tmst [clock format [clock seconds] -format %H:%M:%S]
    }
    puts -nonewline $fn "$tmst <*$source*>"
    if { $auto } { puts -nonewline $fn " (away)" }
    puts $fn " $text"
    close $fn
}

proc log_UPDATE_BUDDY {name user online evil signon idle uclass} {
    if { $::TAC(log) == 0 } { return }
    set fn [open $::TAC(logfile) a]
    if {$online == "T"} {
        if { $::TAC(time12) == 12 } {
            set tmst [clock format [clock seconds] -format %I:%M:%S%p]
        } else {
            set tmst [clock format [clock seconds] -format %H:%M:%S]
        }
        puts $fn "$tmst ** $user has signed on."
    } else {
        if { $::TAC(time12) == 12 } {
            set tmst [clock format [clock seconds] -format %I:%M:%S%p]
        } else {
            set tmst [clock format [clock seconds] -format %H:%M:%S]
        }
        puts $fn "$tmst ** $user has signed off."
    }
    close $fn
}

proc tac_log_outIM {name msg away} {
    if { $::TAC(log) != 1 } { return }
    set fn [open $::TAC(logfile) a]
    if { $::TAC(time12) == 12 } {
        set tmst [clock format [clock seconds] -format %I:%M:%S%p]
    } else {
        set tmst [clock format [clock seconds] -format %H:%M:%S]
    }
    puts -nonewline $fn "$tmst (:$name:) "
    if { $away } { puts -nonewline $fn "(away) " }
    puts $fn "$msg"
    close $fn
}


proc tac_cmd_log {exp line} {
    if { $::TAC(log) == 0 } {
        set ::TAC(log) 1
        set fn [open $::TAC(logfile) a]
        puts $fn "=== Log start [clock format [clock seconds] -format "%A, %B %d %Y %I:%M:%S%p"] ==="
        close $fn
        tac_output "Logging started."
    } else {
        set ::TAC(log) 0
        set fn [open $::TAC(logfile) a]
        puts $fn "=== Log end [clock format [clock seconds] -format "%A, %B %d %Y %I:%M:%S%p"] ==="
        puts $fn ""
        close $fn
        tac_output "Logging stopped."
    }
}

proc tac_cmd_logfile {exp line} {
    if {![regexp -- {^(/[a-zA-Z0-9]+) (.*)$} $line match cmd filename]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    set ::TAC(logfile) $filename
    tac_output "Log file is now $::TAC(logfile)"
}

toc_register_func * IM_IN log_IM_IN
toc_register_func * UPDATE_BUDDY log_UPDATE_BUDDY
toc_register_func * SIGN_ON log_SIGN_ON

tac_register_cmd "^/log$"     tac_cmd_log            "  /log             toggle log on/off"
tac_register_cmd "^/lf "      tac_cmd_logfile        "  /lf filename     set log file name"

set ::TAC(logfile) "./tac.log"
set ::TAC(log) 0
