proc tac_cmd_ver {cmd line} {
    tac_output "Client Version: $::VERSION"

    if {[lsearch [package names] http] != -1} {
        set tokn [::http::geturl "http://users.tmok.com/~smike/ver"]
        upvar #0 $tokn state
        tac_output "Newest Version: $state(body)"
    }
}

proc tac_cmd_shell {exp line} {
    if {![regexp -- {^(\!) (.*)$} $line match cmd exc]} {
        tac_output "Usage: [tac_get_help $exp]"
        return
    }

    set exitcode [catch {tac_output [exec $exc]}]
    if { $exitcode == 1 } { tac_output "An error occurred with the command." }
}

tac_register_cmd "^\! "       tac_cmd_shell          "  ! command        execute shell command"
tac_register_cmd "^/v$"       tac_cmd_ver            "  /v               show the current Tac version"
